import 'package:liblinphone_flutter/models/call_type.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'liblinphone_flutter_method_channel.dart';

abstract class LiblinphoneFlutterPlatform extends PlatformInterface {
  /// Constructs a LiblinphoneFlutterPlatform.
  LiblinphoneFlutterPlatform() : super(token: _token);

  static final Object _token = Object();

  static LiblinphoneFlutterPlatform _instance =
      MethodChannelLiblinphoneFlutter();

  /// The default instance of [LiblinphoneFlutterPlatform] to use.
  ///
  /// Defaults to [MethodChannelLiblinphoneFlutter].
  static LiblinphoneFlutterPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [LiblinphoneFlutterPlatform] when
  /// they register themselves.
  static set instance(LiblinphoneFlutterPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<bool> checkPermissions() {
    throw UnimplementedError('checkPermissions() has not been implemented.');
  }

  Future<bool> initialize() {
    throw UnimplementedError('initialize() has not been implemented.');
  }

  Future<bool> register(
    String username,
    String password,
    String serverIp,
    int serverPort,
  ) {
    throw UnimplementedError('register() has not been implemented.');
  }

  Future<bool> unregister() {
    throw UnimplementedError('unregister() has not been implemented.');
  }

  Future<bool> makeCall(String callTo, bool isVideoEnabled) {
    throw UnimplementedError('makeCall() has not been implemented.');
  }

  Future<bool> answerCall() {
    throw UnimplementedError('answerCall() has not been implemented.');
  }

  Future<bool> hangupCall() {
    throw UnimplementedError('hangupCall() has not been implemented.');
  }

  Future<bool> inCall() {
    throw UnimplementedError('inCall() has not been implemented.');
  }

  Future<CallType> callType() {
    throw UnimplementedError('callType() has not been implemented.');
  }

  Future<bool> toggleVideo() {
    throw UnimplementedError('toggleVideo() has not been implemented.');
  }

  Future<bool> toggleMicrophone() {
    throw UnimplementedError('toggleMicrophone() has not been implemented.');
  }

  Future<bool> stop() {
    throw UnimplementedError('stop() has not been implemented.');
  }
}
